<script lang="ts">
import Vue from 'vue';
import { PropType } from 'vue'; // Import PropType
import {
  MrktoForm,
  OneTrustTroubleWarning,
} from '~/components/common/index.vue';

interface FreeTrialForm {
  header?: string;
  pill?: string;
  title?: string;
  listTitle?: string;
  listItems?: string[];
  form: {
    id: string;
    gated_asset: string;
  };
}

export default Vue.extend({
  name: 'FreeTrialForm',
  components: {
    MrktoForm,
    OneTrustTroubleWarning,
  },
  props: {
    data: {
      type: Object as PropType<FreeTrialForm>,
      required: true,
    },
  },
  methods: {
    onFormSubmit(email: string) {
      this.$emit('submit');
      this.submitted = true;
      if (this.data.form.gated_asset) {
        const emailParam = `lb_email=${email}`; // email is not catching here
        const utmCampaignParam = `utm_campaign=${this.data.form.gated_asset.utm_campaign}`;
        window.location.href = `${this.data.form.gated_asset.link}?${emailParam}&${utmCampaignParam}`;
      }
    },
  },
});
</script>
<template>
  <section>
    <SlpContainer id="interest" class="formSectionWrapper" fluid>
      <SlpContainer>
        <SlpRow>
          <SlpColumn class="formLeft slp-mb-32">
            <!-- Create component for pill -->
            <div v-if="data.pill" class="pill slp-mb-8">
              <SlpIcon
                :v-if="data.pill.icon"
                :name="data.pill.icon.name"
                :variant="data.pill.icon.variant"
                :alt="data.pill.icon.alt"
                :hex-color="data.pill.icon.hex_color"
              />
              <SlpTypography tag="p" variant="body3-bold"
                >{{ data.pill.type }}
              </SlpTypography>
            </div>
            <SlpTypography
              v-if="data.header"
              variant="heading3-bold"
              class="slp-mb-16"
              tag="h3"
            >
              {{ data.header }}
            </SlpTypography>
            <SlpTypography
              v-if="data.title"
              variant="heading2-bold"
              class="slp-mb-32"
              tag="h3"
            >
              {{ data.title }}
            </SlpTypography>
            <SlpTypography
              v-if="data.description"
              tag="div"
              class="slp-mb-32 description"
              variant="body1"
            >
              <span v-html="$md.render(data.description)" />
            </SlpTypography>
            <SlpTypography
              v-if="data.listTitle"
              variant="heading5-bold "
              tag="p"
            >
              {{ data.listTitle }}
            </SlpTypography>
            <ul class="list slp-mb-32">
              <li v-for="item in data.list" :key="item.text" class="item">
                <div class="icon-container">
                  <SlpIcon
                    name="check"
                    class="slp-mr-8"
                    variant="product"
                    slp-color="accent-500"
                    alt="Check icon"
                    size="md"
                  />
                </div>
                <div class="text">
                  <SlpTypography v-if="item.text" tag="p">
                    {{ item.text }}
                  </SlpTypography>
                </div>
              </li>
            </ul>
            <!-- Create component for logo box-->
            <div v-if="data.customers" class="customer-logos slp-p-16">
              <p class="customer-logos__title">{{ data.customers.title }}</p>
              <div class="customer-logos__flex">
                <span
                  v-for="company in data.customers.showcased_enterprises"
                  :id="company.id ? company.id : null"
                  :key="company.alt"
                  :href="company.url"
                  class="customer-logos__item"
                >
                  <img
                    :src="company.image_url"
                    :alt="company.alt ? company.alt : 'company logo'"
                    :class="company.class"
                    preload
                  />
                </span>
              </div>
            </div>
          </SlpColumn>
          <SlpColumn class="form-wrapper">
            <MrktoForm :data="data.form" @submit-success="onFormSubmit" />
            <OneTrustTroubleWarning class="onetrusttrouble" />
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.formSectionWrapper {
  padding: $spacing-48 0;
  background: $color-surface-800;
  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0;
  }
}

.formLeft {
  color: $color-text-300;
  .pill {
    background-color: $color-surface-950;
    display: inline-flex;
    padding: 4px 12px;
    align-items: flex-start;
    gap: 8px;
    border-radius: 20px;
    color: $color-secondary-300;
    p {
      margin-bottom: 0;
    }
    .slp-icon {
      margin-top: 2px;
    }
  }
  h3 {
    font-weight: 660;
  }

  .description {
    &:deep p {
      margin-bottom: 1em;
    }

    &:deep strong {
      font-weight: $font-weight-bold;
    }
  }

  .item {
    display: flex;
    align-items: flex-start;
    margin: $spacing-8 0;
    .text {
      display: flex;
      flex-direction: column;
      gap: 16px;
    }
    .slp-icon {
      width: 24px;
      height: 24px;
    }
  }

  // Customer logos component - iteration needed here
  .customer-logos {
    background-color: $color-surface-700;
    border-radius: 4px;
    padding: 16px;
    display: flex;
    flex-direction: column;
    align-items: center;

    &__title {
      color: $color-text-50;
      font-weight: 660;
      width: 100%;
      text-align: center;
      margin-bottom: 16px;
    }

    &__flex {
      display: flex;
      flex-wrap: wrap;
      justify-content: center;
      gap: 18px;
      width: 100%;
    }

    &__item {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 100px; /* Default width */
      height: 52px; /* Default height */
      width: calc(
        33.333% - 16px
      ); /* Divide space into three equal parts with spacing */
      overflow: hidden;
      text-decoration: none;
      display: flex;
      &#deutsche-telekom {
        text-align: center;
        img {
          width: 32px;
          height: 32px;
        }
      }
      &#airbus,
      &#nvidia,
      &#carfax {
        img {
          max-width: 95.958px;
        }
      }
      &#goldman-sachs {
        img {
          width: 65.304px;
          height: 28.363px;
        }
      }
    }
    img {
      max-width: 100%;
      max-height: 100%;
      object-fit: contain; /* Ensures logos scale while maintaining aspect ratio */
      filter: brightness(0) invert(1);

      &.black {
        filter: none;
      }
    }
  }

  &-icon:hover {
    transform: scale(1.05);
    transition: all 0.2s ease-in-out;
  }
}
.form-wrapper {
  @media (max-width: $breakpoint-lg) {
    width: 100%;
  }

  .form_column {
    margin-bottom: 0 !important;
  }

  :deep {
    .form_header {
      font-size: 22px;
    }
    .mktoGutter {
      display: none !important;
    }
    #mktoForm_1415 {
      @media (min-width: $breakpoint-lg) {
        grid-column-gap: 16px;
        -moz-column-gap: 16px;
        column-gap: 16px;
        display: grid;
        grid-template-columns: 1fr 1fr;
        overflow: hidden;
        width: auto !important;

        .mktoFormRow:has(#LblCountry),
        .mktoFormRow:has(#LblState),
        .mktoFormRow:has(#commentCapture),
        .mktoFormRow:has(.mktoHtmlText),
        .mktoButtonRow {
          grid-column: span 2; /* Apply style to parent if it has a specific child */
        }

        select {
          background-color: white;
          -moz-appearance: none; /* For Firefox */
        }

        .mktoFormRow:has(#commentCapture) {
          margin-top: 12px;
        }
      }
    }
    .onetrusttrouble {
      margin: $spacing-16 $spacing-32;
    }
  }
}
</style>
